const icon = {
  // 数学抽象
  1: {
    unlock: './img/ability_shuxuechouxiang_colorful.png',
    lock: './img/ability_shuxuechouxiang_gray.png',
  },
  // 直观想象
  2: {
    unlock: './img/ability_zhiguanxiangxiang_colorful.png',
    lock: './img/ability_zhiguanxiangxiang_gray.png',
  },
  // 数据分析
  3: {
    unlock: './img/ability_shujufenxi_colorful.png',
    lock: './img/ability_shujufenxi_gray.png',
  },
  // 数学运算
  4: {
    unlock: './img/ability_shuxueyunsuan_colorful.png',
    lock: './img/ability_shuxueyunsuan_gray.png',
  },
  // 逻辑推理
  5: {
    unlock: './img/ability_luojituili_colorful.png',
    lock: './img/ability_luojituili_gray.png',
  },
  // 数学建模
  6: {
    unlock: './img/ability_shuxuejianmo_colorful.png',
    lock: './img/ability_shuxuejianmo_gray.png',
  }
};

/**
 * 创建雷达图的webview代码
 * 支持直接设定width大小来生成适合大小的图形, 文字和图片大小不放大
 * label位置计算公式: 位置 = 100时的初始值 + (100的倍数 - 1) * 增长幅度 - 细节位置偏差
 */
function createInjectScript(abilityScores, score, abilities, width) {
  let setIconString = '';
  setIconString = `
$('.label1 > img').prop({ 'src': abilityScores[0] > 0 ? '${icon[1].unlock}' : '${icon[1].lock}' });
$('.label2 > img').prop({ 'src': abilityScores[1] > 0 ? '${icon[2].unlock}' : '${icon[2].lock}' });
$('.label3 > img').prop({ 'src': abilityScores[2] > 0 ? '${icon[3].unlock}' : '${icon[3].lock}' });
$('.label4 > img').prop({ 'src': abilityScores[3] > 0 ? '${icon[4].unlock}' : '${icon[4].lock}' });
$('.label5 > img').prop({ 'src': abilityScores[4] > 0 ? '${icon[5].unlock}' : '${icon[5].lock}' });
$('.label6 > img').prop({ 'src': abilityScores[5] > 0 ? '${icon[6].unlock}' : '${icon[6].lock}' });
    `;

  return `
$(function() {
    function listenNativeMessage(event) {
        var message = event.detail.message;
        var data = JSON.parse(message);
        drawRazarChart(data.abilityScores, data.scores);
    }
    document.addEventListener('WebViewBridge', listenNativeMessage, false);
});

window.width = ${width};
function transform(array) {
    for (var i = 0; i < 6; i++) {
        array[i] = 25 + ((array[i] * 75) / 100);
    }
}
drawRazarChart([${abilityScores}], ${score});

function drawRazarChart(abilityScores, score) {
    $('.number').text(score);
    $('.score').css({ 'left': width / 2 - 0, 'top': width / 2 - 16 });
    $('.number').css({ 'color': score > 0 ? 'white' : '#bebebe' });
    $('.text').css({ 'color': score > 0 ? 'rgba(187,231,246,0.6)' : 'rgba(190,190,190,0.6)' });
    $('.label1').css({ 'left': 50 + (width / 100 - 1) * 50 - 20, 'top': 5.125 + (width / 100 - 1) * 7.5 - 14 });
    $('.label2').css({ 'left': 90 + (width / 100 - 1) * 86.806 - 10, 'top': 28.75 + (width / 100 - 1) * 28.75 - 30 });
    $('.label3').css({ 'left': 90 + (width / 100 - 1) * 86.806 - 10, 'top': 75.45 + (width / 100 - 1) * 71.75 - 0 });
    $('.label4').css({ 'left': 50 + (width / 100 - 1) * 50 - 20, 'top': 98.875 + (width / 100 - 1) * 92.5 - 16 });
    $('.label5').css({ 'left': 9.4 + (width / 100 - 1) * 13.12 - 20, 'top': 75.45 + (width / 100 - 1) * 71.75 - 0 });
    $('.label6').css({ 'left': 9.4 + (width / 100 - 1) * 13.12 - 20, 'top': 28.75 + (width / 100 - 1) * 28.75 - 30 });
    ${setIconString}
    $('.main').css('width', width + 40).css('height', width);
    $('#container').css('width', width).css('height', width);
    transform(abilityScores);
    $('#container').highcharts({
        chart: {
            polar: true,
            type: 'line',
            events: {
                load: function () {
                    document.getElementsByClassName('highcharts-series-0')[0].firstChild.setAttribute('fill', score > 0 ? 'rgba(22,150,234,0.6)' : 'rgba(190,190,190,0.6)');
                }
            }
        },
        credits: { enabled: false },
        title: { text: null },
        xAxis: {
            labels: {
            enabled:false,
            },
            categories: ['', '', '', '', '', ''],
            tickmarkPlacement: 'on',
            lineWidth: 0,
            gridLineDashStyle: 'Dash',
            gridLineWidth: 1
        },

        yAxis: {
            labels: {
            enabled: false,
            },
            gridLineInterpolation: 'polygon',
            gridLineColor: '#e8e8e8',
            gridLineWidth: 2,
            lineWidth: 0,
            min: 0,
            tickInterval: 25,
            max: 100,
            min: 0
        },
        tooltip: { enabled: false },
        legend: { enabled: false },
        series: [{
            data: abilityScores,
            pointPlacement: 'on',
            color: score > 0 ? '#1696ea' : '#bebebe',
            lineWidth: 2,
            marker: {
                radius: 2.5,
                fillColor: 'white',
                lineColor: score > 0 ? '#1696ea' : '#bebebe',
                lineWidth: 2,
                states: {
                    hover: {
                        enabled: false,
                    },
                    select: {
                        enabled: false,
                    }
                }
            },
            states: {
                hover: {
                    enabled: false
                }
            }
        }]
    });
}
`;
}

export function createInjectEmmitEvent(eventName, message) {
  return `var event = new CustomEvent('${eventName}', {'detail':{'message':'${message}'}});document.dispatchEvent(event)`;
}

export default createInjectScript;
